﻿Imports ImageAreaSelection
Public Class Form1
    Private blockpos As Integer = 2
    Dim units As GraphicsUnit = GraphicsUnit.Pixel
    Dim bm As Bitmap
    Dim imarsel As New AreaSelect
    Dim Out() As Point

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Dim wi, he As Integer
        Dim rct1, rct2 As Rectangle
        Dim OpenFileDialog As New OpenFileDialog
        Dim bmimage As Image
        Dim g As Graphics
        '   OpenFileDialog.InitialDirectory = "D:\R" 'My.Computer.FileSystem.SpecialDirectories.MyDocuments
        OpenFileDialog.CheckFileExists = True
        OpenFileDialog.ShowReadOnly = False
        OpenFileDialog.Filter = "Image Files|*.bmp;*.emf;*.exif;*.gif;*.jpeg;*.jpg;*.png;*.tif;*.tiff;*.wmf|All Files|*.*"
        OpenFileDialog.FilterIndex = 2
        If (OpenFileDialog.ShowDialog(Me) = System.Windows.Forms.DialogResult.OK) Then
            Dim FileName As String = OpenFileDialog.FileName
            Try
                bmimage = Image.FromFile(FileName)
            Catch
                MsgBox("Unknown file type ")
                Exit Sub
            End Try
            wi = bmimage.Width
            he = bmimage.Height
            bm = New Bitmap(wi, he, Imaging.PixelFormat.Format32bppRgb)
            g = Graphics.FromImage(bm)
            rct1 = New Rectangle(0, 0, wi, he)
            rct2 = New Rectangle(0, 0, wi, he)
            g.DrawImage(bmimage, rct2, rct1, units)
            PictureBox1.Image = bm
            Me.PictureBox1.Left = 0
            Me.PictureBox1.Top = 0
            PictureBox1.Refresh()
        End If
    End Sub

    Private Sub PictureBox1_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseDown
        Dim X, Y, i, der, tol, colmodel, colcomp, inranorback As Integer
        Dim ret As Double
        Dim clickpoint As Point
        Dim pf As PointF
        Dim s As String
        Dim c, c1 As Color
        Dim d As Double
        X = e.X
        Y = e.Y
        clickpoint.X = X
        clickpoint.Y = Y

        c = bm.GetPixel(e.X, e.Y)
        If e.Button = Windows.Forms.MouseButtons.Right Then
            imarsel.EyedropperColor = c
        End If
        Label11.BackColor = imarsel.currentcolor ' c
        Label12.BackColor = c
        d = imarsel.ColorDifference(c)
        Label3.Text = Format(d, "0.00")
        If e.Button = Windows.Forms.MouseButtons.Right Then Exit Sub

   
        If CheckBox1.Checked Then
            tol = HScrollBar1.Value
            colmodel = ComboBox3.SelectedIndex
            colcomp = ComboBox2.SelectedIndex
            If CheckBox2.Checked = True Then
                c1 = Label18.BackColor
                inranorback = 1
            Else
                c1 = c
                inranorback = 0
            End If
            der = imarsel.SelectUsingOuterSettings(bm, clickpoint, tol, colmodel, _
            inranorback, colcomp, c1)
        Else
            Button1.Enabled = Button1.Enabled
            der = imarsel.SelectUsingToolbox(bm, clickpoint) 'initialdate(X, Y, bm)
            ComboBox3.SelectedIndex = imarsel.ColrSpaceType
            ComboBox2.SelectedIndex = imarsel.ColorSpaceComponents
            CheckBox2.Checked = (imarsel.InrangeOrFrombackgr = 1)
            HScrollBar1.Value = imarsel.Tolerance
            s = "Tolerance " & HScrollBar1.Value
            Label17.Text = s
            If imarsel.InrangeOrFrombackgr = 1 Then Label18.BackColor = imarsel.currentcolor
        End If

        If der = -1 Then
            Label21.Text = "Error!"
            Exit Sub
        Else
            Label21.Text = CStr(der)
            ReDim Out(der)
            For i = 0 To der
                Out(i) = imarsel.Selectionpoints(i)
            Next i
            If CheckBox3.Checked Then
                ret = imarsel.PolygonArea(Out)
                Label19.Text = CStr(ret)
            End If
            If CheckBox4.Checked Then
                pf = imarsel.PolygonCentroid(Out)
                s = "X " & CStr(pf.X)
                Label20.Text = s
                s = "Y " & CStr(pf.Y)
                Label22.Text = s
            End If
            If CheckBox5.Checked Then
                ret = imarsel.PolygonPerimeter(Out)
                Label23.Text = CStr(ret)
            End If
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        bm = My.Resources.f400a08
        PictureBox1.Image = bm
        PictureBox1.Refresh()
        ReDim Out(8)
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        PictureBox1.Refresh()
    End Sub

    Private Sub PictureBox1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
        Dim a As Integer
        Dim rh, gs, bl As Double
        Dim g As Graphics
        Dim dashValues As Single() = {5, 5}

        Dim WhitePen As Pen = New Pen(System.Drawing.Color.White, 1)
        Dim GRAYPen As Pen = New Pen(System.Drawing.Color.Gray, 1)
        WhitePen.DashStyle = Drawing.Drawing2D.DashStyle.Dash
        WhitePen.DashPattern = dashValues

        g = e.Graphics

        blockpos = blockpos + 2
        If blockpos > 10 Then blockpos = 2

        Dim WhitePen1 As Pen = New Pen(System.Drawing.Color.White, 1)
        WhitePen1.DashStyle = Drawing.Drawing2D.DashStyle.Dash
        WhitePen1.DashPattern = dashValues
        WhitePen1.DashOffset = blockpos

        If Out(0) <> Out(UBound(Out)) Then

            g.DrawLines(GRAYPen, Out)

            Try
                g.DrawLines(WhitePen1, Out)
            Catch
            End Try

        Else
            g.DrawPolygon(GRAYPen, Out)
            Try
                g.DrawPolygon(WhitePen1, Out)
            Catch
            End Try
        End If

        dashValues = Nothing
        WhitePen1.Dispose()
        WhitePen1 = Nothing
        dashValues = Nothing
        WhitePen.Dispose()
        GRAYPen.Dispose()
        WhitePen = Nothing

        If imarsel Is Nothing Then
        Else
            a = imarsel.ColrSpaceType
            colormodeltype(a)
            imarsel.Labcurcolor(rh, gs, bl)
            Label6.Text = Format(rh, "0.00")
            Label8.Text = Format(gs, "0.00")
            Label10.Text = Format(bl, "0.00")
        End If
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        If Not bm Is Nothing Then
            bm.Dispose()
        End If
        Me.Close()
    End Sub

    Private Sub Paste_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Paste.Click

        If My.Computer.Clipboard.ContainsImage Then
            bm = My.Computer.Clipboard.GetImage
            PictureBox1.Image = bm
            Me.PictureBox1.Left = 0
            Me.PictureBox1.Top = 0
            PictureBox1.Refresh()
            ' newformshow()
        Else
            MsgBox("Clipboard does not contain an image", MsgBoxStyle.Exclamation And MsgBoxStyle.OkOnly)
        End If
    End Sub
  
    Private Sub colormodeltype(ByVal index As Integer) 'Handles ComboBox1.SelectedIndexChanged

        Select Case index
            Case 0
                Label5.Text = "R"
                Label7.Text = "G"
                Label9.Text = "B"
            Case 1
                Label5.Text = "1"
                Label7.Text = "2"
                Label9.Text = "3"
            Case 2
                Label5.Text = "L"
                Label7.Text = "a"
                Label9.Text = "b"
            Case 3
                Label5.Text = "H"
                Label7.Text = "S"
                Label9.Text = "L"
            Case 4
                Label5.Text = "H"
                Label7.Text = "S"
                Label9.Text = "B"
            Case 5
                Label5.Text = "L"
                Label7.Text = "C"
                Label9.Text = "H"
            Case 6
                Label5.Text = "L"
                Label7.Text = "U"
                Label9.Text = "V"
            Case 7
                Label5.Text = "Y"
                Label7.Text = "C"
                Label9.Text = "C"
            Case 8
                Label5.Text = "Y"
                Label7.Text = "U"
                Label9.Text = "V"
            Case 9
                Label5.Text = "C"
                Label7.Text = "M"
                Label9.Text = "Y"
            Case 10
                Label5.Text = "X"
                Label7.Text = "Y"
                Label9.Text = "Z"
            Case 11
                Label5.Text = "H"
                Label7.Text = "U"
                Label9.Text = "N"
            Case 12
                Label5.Text = "Y"
                Label7.Text = "X"
                Label9.Text = "Y"
        End Select
    End Sub

    Private Sub PictureBox1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureBox1.MouseMove
        Dim X, Y As Integer
        Dim c As Color
        Dim d As Double
        If e.Button = Windows.Forms.MouseButtons.Right Then
            X = e.X
            Y = e.Y
            Try
                c = bm.GetPixel(X, Y)
            Catch
                Exit Sub
            End Try
            d = imarsel.ColorDifference(c)
            Label3.Text = Format(d, "0.00")
            Label12.BackColor = c
        End If
    End Sub


    Private Sub HScrollBar1_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles HScrollBar1.Scroll
        Dim s As String
        s = "Tolerance " & HScrollBar1.Value
        Label17.Text = s
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        Dim b, b1 As Boolean
        b = CheckBox1.Checked

        Label15.Enabled = b
        Label16.Enabled = b
        ComboBox3.Enabled = b
        ComboBox2.Enabled = b
        CheckBox2.Enabled = b
        Label17.Enabled = b
        HScrollBar1.Enabled = b
        b1 = Not b
        Label5.Enabled = b1
        Label6.Enabled = b1
        Label7.Enabled = b1
        Label8.Enabled = b1
        Label9.Enabled = b1
        Label10.Enabled = b1
        b1 = b And CheckBox2.Checked
        Label18.Enabled = b1
        Button1.Enabled = b1
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        Dim c As Color
        Dim b As Boolean
        b = ColorDialog1.ShowDialog
        If b = True Then
            c = ColorDialog1.Color
            Label18.BackColor = c
        End If
    End Sub

    Private Sub CheckBox2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox2.CheckedChanged
        Dim b As Boolean
        b = CheckBox2.Checked And CheckBox1.Checked
        Label18.Enabled = b
        Button1.Enabled = b
    End Sub

    Private Sub CheckBox3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox3.CheckedChanged
        Label19.Enabled = CheckBox3.Checked
    End Sub

    Private Sub CheckBox4_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox4.CheckedChanged
        Dim b As Boolean
        b = CheckBox4.Checked
        Label20.Enabled = b
        Label22.Enabled = b
    End Sub

    Private Sub CopyToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CopyToolStripMenuItem.Click
        Dim Xmin, Xmax, Ymin, Ymax, i, ub, dum, wi, he As Integer
        Dim g As Graphics
        Dim bi As Bitmap
        ub = UBound(Out)
        Xmin = 200000
        Ymin = 200000
        Xmax = -200000
        Ymax = -200000
        For i = 0 To ub
            dum = Out(i).X
            If dum < Xmin Then Xmin = dum
            If dum > Xmax Then Xmax = dum
            dum = Out(i).Y
            If dum < Ymin Then Ymin = dum
            If dum > Ymax Then Ymax = dum
        Next
        wi = Xmax - Xmin
        he = Ymax - Ymin

        If wi > 1 And he > 1 Then
            bi = New Bitmap(wi, he)
        Else
            Exit Sub
        End If

        Dim Out1() As Point
        ReDim Out1(ub)
        For i = 0 To ub
            Out1(i).X = Out(i).X - Xmin
            Out1(i).Y = Out(i).Y - Ymin
        Next i
        Dim src_rect As New Rectangle(Xmin, Ymin, wi, he)
        Dim dest_rect As New Rectangle(0, 0, wi, he)
        Dim selected_path As New System.Drawing.Drawing2D.GraphicsPath(Drawing2D.FillMode.Winding)
        selected_path.AddLines(Out1)
        g = Graphics.FromImage(bi)
        g.Clear(Color.FromArgb(0, 0, 0, 0))
        g.SetClip(selected_path)
        g.DrawImage(bm, dest_rect, src_rect, GraphicsUnit.Pixel)
        g.Dispose()
        selected_path.Dispose()
        Clipboard.SetDataObject(DirectCast(bi.Clone, Bitmap), True)
        bi.Dispose()
    End Sub

    Private Sub ContentToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ContentToolStripMenuItem.Click
        Try
            Help.ShowHelp(Me, "Help\index.htm")
        Catch
            MessageBox.Show("Help file is absent")
        End Try
    End Sub

    Private Sub AboutToolStripMenuItem2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem2.Click
        Dim ab As New AboutBox1
        ab.ShowDialog()
    End Sub

    Private Sub AreaSelectionOnTheWebToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AreaSelectionOnTheWebToolStripMenuItem.Click
        Help.ShowHelp(Me, "http://www.imagesgenerator.com/components/edgedetection/areaselect.htm")
    End Sub

    Private Sub CheckBox5_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox5.CheckedChanged
        Label23.Enabled = CheckBox5.Checked
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click

    End Sub
End Class
